net-ftp/proftpd: workaround missing auxillary argument to make openrc happy
[slyfox-gentoo.git] / x11-base / xorg-server / xorg-server-1.12.2-r100.ebuild
blob1f1d9525cc573ae02e10f4303fd3998c9ca39fee
1 # Copyright 1999-2012 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/x11-base/xorg-server/xorg-server-1.12.2.ebuild,v 1.2 2012/06/08 13:40:11 chithanh Exp $
5 EAPI=4
7 XORG_DOC=doc
8 inherit flag-o-matic xorg-2 multilib versionator
9 EGIT_REPO_URI="git://anongit.freedesktop.org/git/xorg/xserver"
11 DESCRIPTION="X.Org X servers"
12 KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~sh ~sparc ~x86 ~amd64-fbsd ~x86-fbsd"
14 IUSE_SERVERS="dmx kdrive xnest xorg xvfb"
15 IUSE="${IUSE_SERVERS} ipv6 minimal nptl selinux tslib +udev"
17 RDEPEND=">=app-admin/eselect-opengl-1.0.8
18 dev-libs/openssl
19 media-libs/freetype
20 >=x11-apps/iceauth-1.0.2
21 >=x11-apps/rgb-1.0.3
22 >=x11-apps/xauth-1.0.3
23 x11-apps/xkbcomp
24 >=x11-libs/libpciaccess-0.12.901
25 >=x11-libs/libXau-1.0.4
26 >=x11-libs/libXdmcp-1.0.2
27 >=x11-libs/libXfont-1.4.2
28 >=x11-libs/libxkbfile-1.0.4
29 >=x11-libs/pixman-0.21.8
30 >=x11-libs/xtrans-1.2.2
31 >=x11-misc/xbitmaps-1.0.1
32 >=x11-misc/xkeyboard-config-2.4.1-r3
33 dmx? (
34 x11-libs/libXt
35 >=x11-libs/libdmx-1.0.99.1
36 >=x11-libs/libX11-1.1.5
37 >=x11-libs/libXaw-1.0.4
38 >=x11-libs/libXext-1.0.99.4
39 >=x11-libs/libXfixes-5.0
40 >=x11-libs/libXi-1.2.99.1
41 >=x11-libs/libXmu-1.0.3
42 x11-libs/libXrender
43 >=x11-libs/libXres-1.0.3
44 >=x11-libs/libXtst-1.0.99.2
46 kdrive? (
47 >=x11-libs/libXext-1.0.5
48 x11-libs/libXv
50 !minimal? (
51 >=x11-libs/libX11-1.1.5
52 >=x11-libs/libXext-1.0.5
53 >=media-libs/mesa-7.8_rc[nptl=]
55 tslib? ( >=x11-libs/tslib-1.0 )
56 udev? ( >=sys-fs/udev-150 )
57 >=x11-apps/xinit-1.3
58 selinux? ( sec-policy/selinux-xserver )"
60 DEPEND="${RDEPEND}
61 sys-devel/flex
62 >=x11-proto/bigreqsproto-1.1.0
63 >=x11-proto/compositeproto-0.4
64 >=x11-proto/damageproto-1.1
65 >=x11-proto/fixesproto-5.0
66 >=x11-proto/fontsproto-2.0.2
67 >=x11-proto/glproto-1.4.14
68 >=x11-proto/inputproto-2.1.99.3
69 >=x11-proto/kbproto-1.0.3
70 >=x11-proto/randrproto-1.2.99.3
71 >=x11-proto/recordproto-1.13.99.1
72 >=x11-proto/renderproto-0.11
73 >=x11-proto/resourceproto-1.0.2
74 >=x11-proto/scrnsaverproto-1.1
75 >=x11-proto/trapproto-3.4.3
76 >=x11-proto/videoproto-2.2.2
77 >=x11-proto/xcmiscproto-1.2.0
78 >=x11-proto/xextproto-7.1.99
79 >=x11-proto/xf86dgaproto-2.0.99.1
80 >=x11-proto/xf86rushproto-1.1.2
81 >=x11-proto/xf86vidmodeproto-2.2.99.1
82 >=x11-proto/xineramaproto-1.1.3
83 >=x11-proto/xproto-7.0.22
84 dmx? (
85 >=x11-proto/dmxproto-2.2.99.1
86 doc? (
87 || (
88 www-client/links
89 www-client/lynx
90 www-client/w3m
94 !minimal? (
95 >=x11-proto/xf86driproto-2.1.0
96 >=x11-proto/dri2proto-2.6
97 >=x11-libs/libdrm-2.4.20
100 PDEPEND="
101 xorg? ( >=x11-base/xorg-drivers-$(get_version_component_range 1-2) )"
103 REQUIRED_USE="!minimal? (
104 || ( ${IUSE_SERVERS} )
107 #UPSTREAMED_PATCHES=(
108 # "${WORKDIR}/patches/"
111 PATCHES=(
112 "${UPSTREAMED_PATCHES[@]}"
113 "${FILESDIR}"/${PN}-1.12-disable-acpi.patch
114 "${FILESDIR}"/${PN}-1.12-xf86edidmodes-array-bounds.patch
115 "${FILESDIR}"/${P}-udev-input.patch
118 pkg_pretend() {
119 # older gcc is not supported
120 [[ "${MERGE_TYPE}" != "binary" && $(gcc-major-version) -lt 4 ]] && \
121 die "Sorry, but gcc earlier than 4.0 wont work for xorg-server."
124 pkg_setup() {
125 xorg-2_pkg_setup
127 # localstatedir is used for the log location; we need to override the default
128 # from ebuild.sh
129 # sysconfdir is used for the xorg.conf location; same applies
130 # --enable-install-setuid needed because sparcs default off
131 # NOTE: fop is used for doc generating ; and i have no idea if gentoo
132 # package it somewhere
133 XORG_CONFIGURE_OPTIONS=(
134 $(use_enable ipv6)
135 $(use_enable dmx)
136 $(use_enable kdrive)
137 $(use_enable kdrive kdrive-kbd)
138 $(use_enable kdrive kdrive-mouse)
139 $(use_enable kdrive kdrive-evdev)
140 $(use_enable tslib)
141 $(use_enable !minimal record)
142 $(use_enable !minimal xfree86-utils)
143 $(use_enable !minimal install-libxf86config)
144 $(use_enable !minimal dri)
145 $(use_enable !minimal dri2)
146 $(use_enable !minimal glx)
147 $(use_enable xnest)
148 $(use_enable xorg)
149 $(use_enable xvfb)
150 $(use_enable nptl glx-tls)
151 $(use_enable udev config-udev)
152 $(use_with doc doxygen)
153 $(use_with doc xmlto)
154 --sysconfdir=/etc/X11
155 --localstatedir=/var
156 --enable-install-setuid
157 --with-fontrootdir=/usr/share/fonts
158 --with-xkb-output=/var/lib/xkb
159 --disable-config-hal
160 --without-dtrace
161 --without-fop
162 --with-os-vendor=Gentoo
165 # Xorg-server requires includes from OS mesa which are not visible for
166 # users of binary drivers.
167 mkdir -p "${T}/mesa-symlinks/GL"
168 for i in gl glx glxmd glxproto glxtokens; do
169 ln -s "${EROOT}usr/$(get_libdir)/opengl/xorg-x11/include/$i.h" "${T}/mesa-symlinks/GL/$i.h" || die
170 done
171 for i in glext glxext; do
172 ln -s "${EROOT}usr/$(get_libdir)/opengl/global/include/$i.h" "${T}/mesa-symlinks/GL/$i.h" || die
173 done
174 append-cppflags "-I${T}/mesa-symlinks"
177 src_install() {
178 xorg-2_src_install
180 dynamic_libgl_install
182 server_based_install
184 if ! use minimal && use xorg; then
185 # Install xorg.conf.example into docs
186 dodoc "${AUTOTOOLS_BUILD_DIR}"/hw/xfree86/xorg.conf.example
189 newinitd "${FILESDIR}"/xdm-setup.initd-1 xdm-setup
190 newinitd "${FILESDIR}"/xdm.initd-8 xdm
191 newconfd "${FILESDIR}"/xdm.confd-4 xdm
193 # install the @x11-module-rebuild set for Portage
194 insinto /usr/share/portage/config/sets
195 newins "${FILESDIR}"/xorg-sets.conf xorg.conf
198 pkg_postinst() {
199 # sets up libGL and DRI2 symlinks if needed (ie, on a fresh install)
200 eselect opengl set xorg-x11 --use-old
202 if [[ ${PV} != 9999 && $(get_version_component_range 2 ${REPLACING_VERSIONS}) != $(get_version_component_range 2 ${PV}) ]]; then
203 ewarn "You must rebuild all drivers if upgrading from <xorg-server-$(get_version_component_range 1-2)"
204 ewarn "because the ABI changed. If you cannot start X because"
205 ewarn "of module version mismatch errors, this is your problem."
207 echo
208 ewarn "You can generate a list of all installed packages in the x11-drivers"
209 ewarn "category using this command:"
210 ewarn " emerge portage-utils; qlist -I -C x11-drivers/"
211 ewarn "or using sets from portage-2.2:"
212 ewarn " emerge @x11-module-rebuild"
216 pkg_postrm() {
217 # Get rid of module dir to ensure opengl-update works properly
218 if [[ -z ${REPLACED_BY_VERSION} && -e ${ROOT}/usr/$(get_libdir)/xorg/modules ]]; then
219 rm -rf "${ROOT}"/usr/$(get_libdir)/xorg/modules
223 dynamic_libgl_install() {
224 # next section is to setup the dynamic libGL stuff
225 ebegin "Moving GL files for dynamic switching"
226 dodir /usr/$(get_libdir)/opengl/xorg-x11/extensions
227 local x=""
228 for x in "${D}"/usr/$(get_libdir)/xorg/modules/extensions/lib{glx,dri,dri2}*; do
229 if [ -f ${x} -o -L ${x} ]; then
230 mv -f ${x} "${D}"/usr/$(get_libdir)/opengl/xorg-x11/extensions
232 done
233 eend 0
236 server_based_install() {
237 if ! use xorg; then
238 rm "${D}"/usr/share/man/man1/Xserver.1x \
239 "${D}"/usr/$(get_libdir)/xserver/SecurityPolicy \
240 "${D}"/usr/$(get_libdir)/pkgconfig/xorg-server.pc \
241 "${D}"/usr/share/man/man1/Xserver.1x